/*
	llp_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		LLP_CTRL_MODULE

	MODIFICATIONS:
	Mon Dec 25 22:12:36 EST 2000	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "llp_ctrl.hh"	// definition of LLP_CTRL_MODULE

// flag signifying main loop is to terminate
int llp_module_done = 0;

//signal handler for ^C
extern "C" void llp_module_quit(int sig);
void llp_module_quit(int sig)
{
	llp_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int llp_module_run();

int llp_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	LLP_CTRL_MODULE *llp_ctrl = new LLP_CTRL_MODULE();

	// set the SIGINT handler
	signal(SIGINT, llp_module_quit);

	// enter main loop
	while(!llp_module_done)
	{
		llp_ctrl->controller();

		timer->wait();
	}

	// Delete Modules
	delete llp_ctrl;

	// Delete Timer
	delete timer;
}

