/*
	llp_modulesvr.cc

	This C++ file provides a main routin to start an NML server for this application
	It connects to all of the NML channels used by this application.
	If they are all valid it will call run_nml_servers(), otherwise it will exit immediately.

	MODIFICATIONS:
	Mon Dec 25 22:12:36 EST 2000	Created.

*/

// Include Files
#include <stdlib.h> // exit()
#include "rcs.hh" 	// Common RCS definitions
#include "llp_ctrln.hh" 	// llp_ctrlFormat

// NML Channel Pointers
static RCS_CMD_CHANNEL *llp_ctrl_cmd = NULL;
static RCS_STAT_CHANNEL *llp_ctrl_stat = NULL;
static NML *errlog = NULL;

static int InitNML()
{


	// llp_ctrl
	llp_ctrl_cmd = new RCS_CMD_CHANNEL(llp_ctrlFormat, "llp_ctrl_cmd", "llp_modulesvr", "llp_module.nml");
	if(NULL == llp_ctrl_cmd)
		return -1;
	if(!llp_ctrl_cmd->valid())
		return -1;

	llp_ctrl_stat = new RCS_STAT_CHANNEL(llp_ctrlFormat, "llp_ctrl_sts", "llp_modulesvr", "llp_module.nml");
	if(NULL == llp_ctrl_stat)
		return -1;
	if(!llp_ctrl_stat->valid())
		return -1;

	errlog = new NML(nmlErrorFormat, "errlog", "llp_modulesvr", "llp_module.nml");
	if(NULL == errlog)
		return -1;
	if(!errlog->valid())
		return -1;

	return 0;
}

static void DeleteNML()
{

	// llp_ctrl
	if(NULL != llp_ctrl_cmd)
	{
		delete llp_ctrl_cmd;
		llp_ctrl_cmd = NULL;
	}

	if(NULL != llp_ctrl_stat)
	{
		delete llp_ctrl_stat;
		llp_ctrl_stat = NULL;
	}

	if(NULL != errlog)
	{
		delete errlog;
		errlog = NULL;
	}

}

// Main 
#ifdef VXWORKS
extern "C" int llp_modulesvr_run();

int llp_modulesvr_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	if(InitNML() < 0)
	{
		DeleteNML();
		rcs_exit(-1);
	}

	run_nml_servers();

}

